<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>Linear Search</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="linear-search">Linear Search</h1>
    <h4 id="problem-statement">Problem Statement</h4>
    <p>
      Given an array of n elements, write a function to search for the index of
      a given element (target)
    </p>
    <h4 id="approach">Approach</h4>
    <ul>
      <li>Start iterating with the first element in the array.</li>
      <li>Compare it with the target element</li>
      <li>If it is equal to the target element then return the index</li>
      <li>Else continue iterating</li>
      <li>Return -1 if target element is not found in the array</li>
    </ul>
    <h4 id="time-complexity">Time Complexity</h4>
    <p>
      O(n) Worse Case<br />
      O(1) Best Case (If first element of array is the target element)
    </p>
    <h4 id="space-complexity">Space Complexity</h4>
    <p>O(1)</p>
    <h4 id="example">Example</h4>
    <pre><code>arr = [1, 3, 9, 5, 0, 2]  

target = 5
Linear Search should return index 3 as 5 is on index 3     

target = 6           
Linear Search should return -1 as 6 is not present in the array</code></pre>
    <h4 id="code-implementation-links">Code Implementation Links</h4>
    <ul>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Java/blob/master/Searches/LinearSearch.java"
          >Java</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/C-Plus-Plus/blob/master/Search/Linear%20Search.cpp"
          >C++</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Python/blob/master/searches/linear_search.py"
          >Python</a
        >
      </li>
    </ul>
    <h4 id="video-explanation">Video Explanation</h4>
    <p>
      <a href="https://www.youtube.com/watch?v=CX2CYIJLwfg"
        >A CS50 video explaining the Linear Search Algorithm</a
      >
    </p>
    <h4 id="animation-explanation">Animation Explanation</h4>
    <ul>
      <li>
        <a href="https://boardhub.github.io/tute/?wd=linearSearchAlgo"
          >Tute Board</a
        >
      </li>
    </ul>
  </body>
</html>
